%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%mopt= 1=DES 3=MAT 4=GA 5=User method d'optimisation

%nbgrad= nbre iter grad
%method= 1=grad 2=rand
%normgrad= norm du grad 1 on 0 off
%epsfd= gradient perturbation
%retdm number of random direction retry
%conj conjugate gradient
%gamgc= ordre of SDM
%iordre= type de gradient 1= T1 2 =T2 3=U 4=Matl
%rho00=rho init
%autorho 1 on 0 off
%srho number of rho iter
%initcond2= 0 x0 1=x.0

%mtool= elire method 1=fminsearch 2=fmincon 3=lsqnonlin 4=fminunc
%5=Patternsearch 6= Simulated annealing
%mateval= Iteration Number
%hess=Hessian Version for fmincon 1=User 0=Matlab
%mopt2=Hessian Method for fminnunc 0=BFGS 1=SD 2=DFP
%mopt3=Hessian Method for lsqnonlin 0=Lvenberg MArq on /off

%spinit 0=vinit 1=rnd 2=xoptg
%nbext1= iteration des couches externes
%nbext2=number of layer
%nbbvp=  iter couche 
%methodt= mthodes de tir 1=ball 2=rnd 3=attr
%radb= radius of the ball
%epsijs= stop criterium

%gaver= Version of GA 0=GOP 1=Matlab 
%Npop= Populaiton Size 
%Ngen= Generation Number 
%pm= Mutation Probability 
%pc= Cross Over Probability 
%Refb= Refinment Parameter

%fsdate= Date added to Directory

%teste= computed point?
%Pausette= make a pause between each iteration
%passerr= Stop in error computation
%passerrval= Funcitonal Value in cases of errors.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp(' ')
disp('***********************')
disp('* GOP Options summary *')
disp('***********************')
disp(' ')
disp('General Algorithm Options')
disp('*****************************')
disp(' ')
  disp(['Stopping Criterium: ' num2str(epsijs)])
    if (stopcrit==0)
      disp(['Type of stopping criterium: Proportional reduction'])
    elseif (stopcrit==1)
      disp(['Type of stopping criterium: Value to reach'])
       elseif (stopcrit==2)
      disp(['Type of stopping criterium: Benchmark test'])
      disp(['Point to reach: Benchmark test=' num2str(reachpoint) ' | precision 1=' num2str(e1reachpoint) ' | precision 2=' num2str(e2reachpoint) ])
      disp(['Maximum number of funcitonal evaluation=' num2str(evalumax) ]); 
    else
      disp(['Type of stopping criterium: ERROR'])
    end
    
disp(' ')
disp('Multi-Layer Algorithm Options')
disp('*****************************')
disp(' ')
if icoa==0
disp('--- Desactivated ---')
else
  disp(['Number Of External Layer: ' num2str(nbext2)])
  disp(['Iteration Of External Layer: ' num2str(nbext1)])
  disp(['Iteration Of Internal Layer: ' num2str(nbbvp)])
    if (spinit==0)
      disp(['First Initial Condition: Fixed in userinit'])
    elseif (spinit==1)
      disp(['First Initial Condition: Random'])
       elseif (spinit==2)
      disp(['First Initial Condition: Previous optimized point'])
    else
      disp(['First Initial Condition: ERROR'])
    end
   if (methodt==1)
      disp(['Optimization method: Secant'])
      disp(['Generation Ball Radius: ' num2str(radb)])    
    elseif (methodt==2)
      disp(['Optimization method: Secant'])
        disp(['Generation Ball Radius: Full']) 
       elseif (methodt==3)
      disp(['Optimization method: Attraction secant method'])    
    else
      disp(['Optimization method: ERROR'])
   end
   disp(['Value of the funcitonal minimum or lower bound: ' num2str(calsec)])

     if (avrep==0)
      disp(['Blocked linear search: Continue'])
    elseif (avrep==1)
      disp(['Blocked linear search: Random restart'])
       elseif (avrep==2)
      disp(['Blocked linear search: Stop'])
    end
end
disp(' ')
disp('Core Optimization Method Options')
disp('***********************************')
disp(' ')

if (goppar==1)
    disp('Parallel computing Activated.')
end
if (mopt==1)
  disp('Method: GOP Descent Method')
  disp(['Iteration Number: ' num2str(nbgrad)])
  disp(['Second Order Coefficient: ' num2str(gam200)])
   if (gamdeg==0)
      disp(['Second Order Coefficient value is fixed.'])
  else
        disp(['Second Order Coefficient value linearly decrease from given value to 0.'])
   end
  
  if (initcond2==0)
      disp(['Optimized Initial Condition: x0'])
  elseif (initcond2==1)
      disp(['Optimized Initial Condition: dx0/dt'])
  else
       disp(['Optimized Initial Condition: ERROR'])
  end
  
  if (method==1)
  disp(['Descent Direction: Gradient'])  
  if (iordre==1)
  disp(['Gradient Type: Taylor 1'])
    disp(['Perturbation Parameter: ' num2str(epsfd)])
  elseif (iordre==2)
  disp(['Gradient Type: Taylor 2'])
    disp(['Perturbation Parameter: ' num2str(epsfd)])
  elseif (iordre==3)
  disp(['Gradient Type: User'])
  else
  disp(['Gradient Type: ERROR'])
  end
   if (conj==1)
  disp(['Conjugate: On'])
  elseif (conj==0)
  disp(['Conjugate: Off'])    
   else
       disp(['Conjugate: Error'])
   end
  elseif (method==2)
  disp(['Descent Direction: Random'])  
    disp(['Perturbation parameter: ' num2str(retdm)])  
else
     disp(['Descent Direction: ERROR']) 
end
     if (normgrad==1)
  disp(['Direction norm: Normalized'])
  elseif (normgrad==0)
  disp(['Direction norm: Keeped'])    
   else
       disp(['Direction norm: ERROR'])
     end
     
      if (autorho==1)
  disp(['Initial Rho: Automatic'])
  elseif (autorho==0)
         disp(['Initial Rho: ' num2str(rho00)])
      else
          disp(['Initial Rho: ERROR'])
      end
         disp(['Rho Search Iterations: ' num2str(srho)])

elseif (mopt==4)
  if (gaver==0)  
  disp('Method: Genetic Algorithm - GOP Version')
  elseif (gaver==1)  
      disp('Method: Genetic Algorithm - Matlab Version')
      if isempty(usermatopt)==0
    disp(['Additional Matlab optimization algorithm options ''usermatopt'' defined by user.']);
end
  else
      disp('Method: Genetic Algorithm - ERROR')
  end
  disp(['Generation Number: ' num2str(Ngen)])
  disp(['Population Size: ' num2str(Npop)])
  disp(['Cross Over Probability: ' num2str(pc)])
  disp(['Mutation Probability: ' num2str(pm)])
  if (gaver==0)
    disp(['Refinement Parameter: ' num2str(Refb)])    
  end

elseif (mopt==3)
  if (mtool==1)  
  disp('Method: Matlab - fminsearch')
  if isempty(usermatopt)==0
    disp(['Additional Matlab optimization algorithm options ''usermatopt'' defined by user.']);
end
  disp(['Iteration Number: ' num2str(mateval)])
  
  elseif (mtool==5)  
  disp('Method: Matlab - pattern search')
  if isempty(usermatopt)==0
    disp(['Additional Matlab optimization algorithm options ''usermatopt'' defined by user.']);
end
  disp(['Iteration Number: ' num2str(mateval)])
  
    elseif (mtool==6)  
  disp('Method: Matlab - simulated annealing')
  if isempty(usermatopt)==0
    disp(['Additional Matlab optimization algorithm options ''usermatopt'' defined by user.']);
end
  disp(['Iteration Number: ' num2str(mateval)])
      
  elseif (mtool==3)  
  disp('Method: Matlab - lsqnonlin')
  if isempty(usermatopt)==0
    disp(['Additional Matlab optimization algorithm options ''usermatopt'' defined by user.']);
end
  disp(['Iteration Number: ' num2str(mateval)])
     if (mopt3==1)
  disp(['Hessian: Gauss-Newton'])
  elseif (mopt3==0)
  disp(['Hessian: Levenberg-Marquart'])    
   else
       disp(['Hessian: Error'])
     end

  elseif (mtool==4)
  disp('Method: Matlab - fminnunc')
  if isempty(usermatopt)==0
    disp(['Additional Matlab optimization algorithm options ''usermatopt'' defined by user.']);
end
  disp(['Iteration Number: ' num2str(mateval)]) 
    if (method==1)
  disp(['Descent Direction: Gradient'])  
  if (iordre==1)
  disp(['Gradient Type: Taylor 1'])
    disp(['Perturbation Parameter: ' num2str(epsfd)])
  elseif (iordre==2)
  disp(['Gradient Type: Taylor 2'])
    disp(['Perturbation Parameter: ' num2str(epsfd)])
  elseif (iordre==3)
  disp(['Gradient Type: User'])
  elseif (iordre==4)
  disp(['Gradient Type: Matlab'])
  else
  disp(['Gradient Type: ERROR'])
  end
   if (mopt2==0)
  disp(['Hessian: BFGS'])
   elseif (mopt2==1)
  disp(['Hessian: Steepest Descent'])  
  elseif (mopt2==2)
  disp(['Hessian: David-Fenchell-Powell'])   
   else
       disp(['Hessian: Error'])
   end
  elseif (method==2)
  disp(['Descent Direction: Random'])  
    disp(['Perturbation parameter: ' num2str(retdm)])  
else
     disp(['Descent Direction: ERROR']) 
    end
 
  elseif (mtool==2)  
  disp('Method: Matlab - fmincon')
  if isempty(usermatopt)==0
    disp(['Additional Matlab optimization algorithm options ''usermatopt'' defined by user.']);
end
  disp(['Iteration Number: ' num2str(mateval)]) 
    if (method==1)
  disp(['Descent Direction: Gradient'])  
  if (iordre==1)
  disp(['Gradient Type: Taylor 1'])
    disp(['Perturbation Parameter: ' num2str(epsfd)])
  elseif (iordre==2)
  disp(['Gradient Type: Taylor 2'])
    disp(['Perturbation Parameter: ' num2str(epsfd)])
  elseif (iordre==3)
  disp(['Gradient Type: User'])
  elseif (iordre==4)
  disp(['Gradient Type: Matlab'])
  else
  disp(['Gradient Type: ERROR'])
  end
   if (hess==1)
  disp(['Hessian: Matlab'])
  elseif (hess==0)
  disp(['Hessian: User'])    
   else
       disp(['Hessian: Error'])
   end
  elseif (method==2)
  disp(['Descent Direction: Random'])  
    disp(['Perturbation parameter: ' num2str(retdm)])  
else
     disp(['Descent Direction: ERROR']) 
    end

  else
      disp('Method: Matlab - ERROR')
  end
  
elseif (mopt==5)
    disp('Method: User defined')
    
elseif (mopt==6)
    disp('Method: CRS')    

disp(['Populaiton Size: ' num2str(Npop)]) 
disp(['Maximum funcitonal evaluation: ' num2str(CRSMAX)]) 
disp(['Success Rate: ' num2str(CRSpm)]) 
    
else
    disp('Method: ERROR')
end



disp(' ')
disp('Output Options')
disp('*****************************')
disp(' ')
  if (fsdate==1)
  disp(['Output Directory: ' savedir ' + Date'])
  else
      disp(['Output Directory: ' savedir])
  end
  disp(['Result File: ' fileresult])
  disp(['General Convergence File: ' fileconv])
  disp(['Best Element Convergence File: ' filebconv])
  if (savefile==0)
  disp(['Convergence Write Frequency: Real Time'])
  else
  disp(['Convergence Write Frequency: After main iterations'])    
  end
  
  disp(['Computed Points File: ' elevo])
    if (login==0)
  disp(['Points Saved: None'])
    elseif (login==1)
  disp(['Points Saved: All'])
  elseif (login==2)
  disp(['Points Saved: Only Best'])
    else
      disp(['Points Saved: ERROR'])
  end  
  disp(['Movie File: ' filefilm])
  if (length(mailto)>0)
  disp(['User E-Mail Adress: ' mailto])
  else
  disp(['User E-Mail Adress: None'])      
  end

disp(' ')
disp('Processing Options')
disp('*****************************')
disp(' ')

  if (savemem==1)
      disp(['Save matlab memmory: Yes'])
  else
   disp(['Save matlab memmory: No'])
  end
  if (teste==1)
  disp(['Verifying Computed Points: Yes'])
  elseif (teste==2)
      disp(['Verifying Computed Points: Only Record Points'])
  else
   disp(['Verifying Computed Points: No'])
  end
  
  if (pausette==1)
      disp(['Pause Between Each Cost Funciton Evaluation: Yes'])
  else
   disp(['Pause Between Each Cost Funciton Evaluation: No'])
  end
  
  if (passerr==1)
      disp(['Stop Proces If Error Occurs During Funcitonal Evaluation: Yes'])
  else
   disp(['Stop Proces If Error Occurs During Funcitonal Evaluation: No'])
   disp(['Function Value In Cases Of Errors: ' num2str(passerrval)])  
  end